<template>
    <div>
        <div v-if="invalid">
            <div class="alert alert-danger text-center" role="alert">Invalid Username and password! If you are not a
                registered user, you can register
                <router-link to="/register"><a>here</a></router-link>
            </div>
        </div>
        <form @submit.prevent="onSubmit" style="margin: 40px 0">
            <div class="form-group">
                <label for="username">Username</label>
                <input type="text"
                       class="form-control"
                       id="username"
                       placeholder="Enter username"
                       v-model="username"
                       :class="{'is-invalid': $v.username.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.username.required">
                            Please enter the username.
                        </span>
                </span>
            </div>

            <div class="form-group">
                <label for="password">Password</label>
                <input type="password"
                       class="form-control"
                       id="password"
                       placeholder="Password"
                       v-model="password"
                       :class="{'is-invalid': $v.password.$error}"/>
                <span class="invalid-feedback">
                        <span v-if="!$v.password.required">
                            Please enter the password.
                        </span>
                </span>
            </div>

            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px">
                Login
            </button>
        </form>
    </div>
</template>

<script>
    import {required} from 'vuelidate/lib/validators';
    import axios from "axios";

    export default {
        data() {
            return {
                username: '',
                password: '',
                invalid: false
            }
        },
        validations: {
            username: {
                required
            },
            password: {
                required
            }
        },
        methods: {
            onSubmit() {
                this.$v.$touch();
                let userData = new FormData();
                userData.append('username', this.username)
                userData.append('password', this.password)
                axios.post('http://localhost:8000/api/login.php', userData)
                    .then((res) => {
                        this.$store.dispatch('login', res.data.username);
                        this.$router.replace('/shop');
                    }).catch((err) => {
                    console.log(err);
                    this.invalid = true;
                });
            }
        }
    }
</script>